// Imports
import { RandomString } from "/services/common/common.js";
import * as Auth from "/services/auth/auth.js";
import * as ClientDetails from "/components/bankerPage/clientDetails.js";

// DOM elements

// local variables
let current_user;

export async function mount(where) {
  const clientPage = new ClientPage();
  await clientPage.mount(where);
}

class ClientPage {
  constructor() {
    // Random id seed
    this.prefix = RandomString(8);
  }

  async mount(where) {
    document.getElementById(where).innerHTML = /* HTML */ `
      <div class="container">
        <h1 class="title">Ma banque</h1>
      </div>

      <section class="section">
        <div class="columns">
          <div class="column is-one-third">
            <h5 class="title is-5">Mes comptes</h5>
            <div id="bank-accounts"></div>
          </div>
          <div class="column">
            <h5 class="title is-5">Compte bancaire n°<em id="account-title"> Veuillez sélectionner un compte</em></h5>
            <div class="container">
              <div id="bank-account"></div>
            </div>
          </div>
        </div>
      </section>
    `;
    current_user = await Auth.GetUser();

    let client = await Auth.getClientByUserID(current_user.id, current_user);
    ClientDetails.mount("bank-accounts", client);
  }
}
