// Imports
import * as Messages from "/services/messages/messages.js";

// Local variables
let user;

export async function GetUser() {
  if (user != undefined) {
    return user;
  }
  try {
    const response = await fetch("/api/common/WhoAmI");
    if (response.status !== 200) {
      throw new Error(`Not authenticated (status ${response.status})`);
    }
    user = await response.json();
    return user;
  } catch (e) {
    Messages.Show("is-warning", e.message);
    console.error(e);
    location.hash = "#login";
  }
}

export async function getClientByUserID(userID, current_user) {
  let clientToSend = undefined;
  const response = await fetch("/api/UserClients/", {
    method: "GET",
    headers: new Headers({
      "XSRF-Token": current_user.xsrftoken,
    }),
  });
  if (response.status !== 200) {
    throw new Error(`Could not get clients (status ${response.status})`);
  }
  let clients = await response.json();
  clients.forEach((client) => {
    if (client.UserID == userID) {
      clientToSend = client;
    }
  });
  return clientToSend;
}
